#include <fstream>
#include <algorithm>
#include <iostream>
#include <vector>
#include <cstring>

using namespace std;

struct jump{
    char pattern[12][12];
    int R, C, K, T, idx; // K -> Coefficient, T -> Minimum
};

int N, M, P;

int a[64][64];
int rema[64][64];

vector < jump > v;
vector < int > outX, outY, outIDX;

jump getJump (){
    jump res;
    char ch;

    cin >> res.R >> res.C >> res.K >> res.T;

    for ( int i = 0; i < res.R; ++i )
        for ( int j = 0; j < res.C; ++j ){
            cin >> ch;
            res.pattern[i][j] = ch - '0';
        }

    return res;
}

void scan(){
    cin >> N >> M >> P;

    for ( int i = 0; i < N; ++i )
        for ( int j = 0; j < M; ++j )
            cin >> a[i][j];

    for ( int i = 0; i < P; ++i ){
        v.push_back ( getJump() );
        v.back().idx = i;
    }
}

pair < int, int > findBest ( jump t ){
    int R = t.R, C = t.C;
    pair < int, int > res =make_pair ( -1, -1 );
    int st = -1e9;

    for ( int i = 0; i + R <= N; ++i )
        for ( int j = 0; j + C <= M; ++j ){
            int sum = 0, bad = 0;
            for ( int x = 0; x < R; ++x )
                for ( int y = 0; y < C; ++y )
                    if ( t.pattern[x][y] == 1 ){
                        if ( a[i + x][j + y] < t.T ){
                            bad = 1;
                            x = R;
                            break;
                        }
                        else
                            sum += a[i + x][j + y];
                    }

            if ( !bad && st < sum ){
                st = sum;
                res = make_pair ( i, j );
            }
        }
  //  cout << st << endl;
    return res;
}
pair < int, int > solve ( vector < jump > v, int toPrint ){
    pair < int, int > res ( 0, 0 );
    memcpy ( a, rema, sizeof ( a ) );
 //   cout << v[0].R << " " << v[0].C << endl;
    for ( int i = 0; i < v.size(); ++i ){
        pair < int, int > pos = findBest ( v[i] );
        if ( pos.first == -1 )
            break;
        //cout << pos.first << " " << pos.second << endl;

        for ( int x = pos.first; x < pos.first + v[i].R; ++x )
            for ( int y = pos.second; y < pos.second + v[i].C; ++y )
                if ( v[i].pattern[x - pos.first][y - pos.second] ){
                    res.first += a[x][y];
                    a[x][y] /= v[i].K;
                }

        if ( toPrint ){
            outX.push_back ( pos.first );
            outY.push_back ( pos.second );
            outIDX.push_back ( v[i].idx );
        }
        res.second++;
    }

  //  cout << res.first << " " << res.second << endl;
    return res;
}

int ones ( jump t ){
    int res = 0;

    for ( int i = 0; i < t.R; ++i )
        for ( int j = 0; j < t.C; ++j )
            res += t.pattern[i][j];

    return res;
}
bool ff ( jump t1, jump t2 ){
    return ones ( t1 ) * t1.T > ones ( t2 ) * t2.T;
}

int f ( jump t1, jump t2 ){
    return t1.K < t2.K;
}
void solve(){
    memcpy ( rema, a, sizeof ( a ) );
    vector < jump > sol;
    sort ( v.begin(), v.end(), f );
    int step = 1;
    if ( P > 50 ) step = 5;
    for ( int i = 0; i < P; ++i ){
        vector < jump > t;
        pair < int, int > best, cur;
        sol.insert ( sol.begin(), v[i] );
        best = solve ( sol, 0 );
        t = sol;

        for ( int i = step; i < sol.size(); i += step ){
            swap ( t[i], t[i - step] );
     //       cout << t[i].idx << endl;
            cur = solve ( t, 0 );

            if ( cur > best ){
                best = cur;
                sol = t;
            }

        }
    }

    pair < int, int > cnt = solve ( sol, 1 );
/*
for ( int i = 0; i < N; ++i ){
        for ( int j = 0; j < M; ++j )
            cout << rema[i][j] << " ";
        cout << endl;
    }*/
    cout << outX.size() << endl;

    for ( int i = 0; i < outX.size(); ++i )
        cout << outIDX[i] + 1 << " " << outX[i] + 1 << " " << outY[i] + 1 << endl;

    cout << cnt.first << " " << cnt.second << endl;
/*
    for ( int i = 0; i < N; ++i ){
        for ( int j = 0; j < M; ++j )
            cout << a[i][j] << " ";
        cout << endl;
    }*/
}

int main(){
    freopen ( "parash.in", "r", stdin );
    freopen ( "parash.out", "w", stdout );
    scan();
    solve();
}
